import type { KeycloakAdapter, KeycloakInstance, KeycloakLoginOptions, KeycloakLogoutOptions, KeycloakRegisterOptions } from './types';
declare class Adapter implements KeycloakAdapter {
    private kcClient;
    private inAppBrowserOptions?;
    constructor(kcClient: KeycloakInstance, inAppBrowserOptions?: {
        showTitle?: boolean | undefined;
        toolbarColor?: string | undefined;
        secondaryToolbarColor?: string | undefined;
        enableUrlBarHiding?: boolean | undefined;
        enableDefaultShare?: boolean | undefined;
        forceCloseOnRedirection?: boolean | undefined;
        animations?: {
            startEnter: string;
            startExit: string;
            endEnter: string;
            endExit: string;
        } | undefined;
        headers?: {
            [key: string]: string;
        } | undefined;
    } | {
        dismissButtonStyle?: "cancel" | "done" | "close" | undefined;
        preferredBarTintColor?: string | undefined;
        preferredControlTintColor?: string | undefined;
        readerMode?: boolean | undefined;
        animated?: boolean | undefined;
        modalPresentationStyle?: "none" | "automatic" | "fullScreen" | "pageSheet" | "formSheet" | "currentContext" | "custom" | "overFullScreen" | "overCurrentContext" | "popover" | undefined;
        modalTransitionStyle?: "coverVertical" | "flipHorizontal" | "crossDissolve" | "partialCurl" | undefined;
        modalEnabled?: boolean | undefined;
        enableBarCollapsing?: boolean | undefined;
        ephemeralWebSession?: boolean | undefined;
    } | undefined);
    /**
     * Start login process
     *
     * @param {KeycloakLoginOptions} options Login options
     */
    login(options?: KeycloakLoginOptions): Promise<void>;
    logout(options?: KeycloakLogoutOptions): Promise<void>;
    register(options?: KeycloakRegisterOptions): Promise<void>;
    accountManagement(): Promise<void>;
    redirectUri(options?: {
        redirectUri?: string;
    }): string;
}
export default Adapter;
